(function ($) {
  'use strict';

  /**
   * All of the code for your admin-facing JavaScript source
   * should reside in this file.
   *
   * Note: It has been assumed you will write jQuery code here, so the
   * $ function reference has been prepared for usage within the scope
   * of this function.
   *
   * This enables you to define handlers, for when the DOM is ready:
   *
   * $(function() {
   *
   * });
   *
   * When the window is loaded:
   *
   * $( window ).load(function() {
   *
   * });
   *
   * ...and/or other possibilities.
   *
   * Ideally, it is not considered best practise to attach more than a
   * single DOM-ready or window-load handler for a particular page.
   * Although scripts in the WordPress core, Plugins and Themes may be
   * practising this, we should strive to set a better example in our own work.
   */

  /* Widget trigger script */
  $(window).on('load widget-added widget-updated', function () {
    $('.widget-liquid-right .catch-instagram-feed-gallery-widget-layout').each(
      function (k, v) {
        if ('default' === $(v).val()) {
          $('.catch-instagram-feed-gallery-widget-padding').parent('p').hide();
          $('.catch-instagram-feed-gallery-widget-column').parent('p').hide();
          $('.catch-instagram-feed-gallery-widget-link-type')
            .parent('p')
            .show();
        } else {
          $('.catch-instagram-feed-gallery-widget-padding').parent('p').show();
          $('.catch-instagram-feed-gallery-widget-column').parent('p').show();
          $('.catch-instagram-feed-gallery-widget-link-type')
            .parent('p')
            .show();
        }
      }
    );
  });

  $(function () {
    $(
      '.widget-liquid-right .catch-instagram-feed-gallery-widget-link-type'
    ).each(function (k, v) {
      if ('none' == $(v).val()) {
        $(this)
          .parent()
          .parent('.widget-content')
          .find('.catch-instagram-feed-gallery-widget-link-text')
          .parent('p')
          .hide();
      } else if ('load_more' === $(v).val()) {
        $(this)
          .parent()
          .parent('.widget-content')
          .find('.catch-instagram-feed-gallery-widget-link-text')
          .parent('p')
          .show();
        $(this)
          .parent()
          .parent('.widget-content')
          .find('.catch-instagram-feed-gallery-widget-link-text')
          .val('Load More');
      } else {
        $(this)
          .parent()
          .parent('.widget-content')
          .find('.catch-instagram-feed-gallery-widget-link-text')
          .parent('p')
          .show();
        $(this)
          .parent()
          .parent('.widget-content')
          .find('.catch-instagram-feed-gallery-widget-link-text')
          .val('View On Instagram');
      }
    });

    $('#catch_instagram_feed_gallery_widget_shortcode_link_type').on(
      'change',
      function () {
        if ('none' === $(this).val()) {
          $(this)
            .parent()
            .parent('#catch-instagram-feed-gallery-widget-shortcode-wrapper')
            .find('.catch_instagram_feed_gallery_widget_shortcode_link_text')
            .parent('p')
            .hide();
        } else if ('load_more' === $(this).val()) {
          $(this)
            .parent()
            .parent('#catch-instagram-feed-gallery-widget-shortcode-wrapper')
            .find('.catch_instagram_feed_gallery_widget_shortcode_link_text')
            .parent('p')
            .show();
          $(this)
            .parent()
            .parent('#catch-instagram-feed-gallery-widget-shortcode-wrapper')
            .find('.catch_instagram_feed_gallery_widget_shortcode_link_text')
            .val('Load More');
        } else {
          $(this)
            .parent()
            .parent('#catch-instagram-feed-gallery-widget-shortcode-wrapper')
            .find('.catch_instagram_feed_gallery_widget_shortcode_link_text')
            .parent('p')
            .show();
          $(this)
            .parent()
            .parent('#catch-instagram-feed-gallery-widget-shortcode-wrapper')
            .find('.catch_instagram_feed_gallery_widget_shortcode_link_text')
            .val('View On Instagram');
        }
      }
    );

    /* Show More event */
    var open = false;
    $('.show-more').on('click', function () {
      if (!open) {
        $(this).addClass('open');
        $(this).html(
          'Hide Options<i class="dashicons dashicons-arrow-up"></i>'
        );
        open = true;
      } else {
        $(this).removeClass('open');
        $(this).html(
          'More Options<i class="dashicons dashicons-arrow-down"></i>'
        );
        open = false;
      }
      $(this).next('.more-options').toggle();
    });
  });
  var open = false;

  $(document).on('widget-added widget-updated', function (e, widget) {
    $('.show-more').on('click', function () {
      if (open === false) {
        $(this).html(
          'Hide Options<i class="dashicons dashicons-arrow-up"></i>'
        );
        $(this).next('.more-options').slideDown();
        open = true;
      } else {
        $(this).html(
          'More Options<i class="dashicons dashicons-arrow-down"></i>'
        );
        $(this).next('.more-options').slideUp();
        open = false;
      }
    });
  });

  /* $(document).on('widget-updated', function(e, widget) {

        $('.show-more').on('click', function() {
            $(this).next('.more-options').toggle();
        });

        $(".show-more").toggle(function() {
            $(this).html('Hide Options<i class="dashicons dashicons-arrow-up"></i>')
                .stop();
        }, function() {
            $(this).html('More Options<i class="dashicons dashicons-arrow-down"></i>')
                .stop();
        });
    }); */

  $(window).on('load widget-added widget-updated', function () {
    $('body').on(
      'change',
      '.catch-instagram-feed-gallery-widget-type',
      function () {
        if ('tags' === $(this).val()) {
          $(this).parent('p').next('p').show();
          $(this).parent('p').next('p').next('p').show();
        } else {
          $(this).parent('p').next('p').hide();
          $(this).parent('p').next('p').next('p').hide();
        }
      }
    );

    $('body').on(
      'change',
      '.catch-instagram-feed-gallery-widget-layout',
      function () {
        if ('default' === $(this).val()) {
          $('.catch-instagram-feed-gallery-widget-padding').parent('p').hide();
          $('.catch-instagram-feed-gallery-widget-column').parent('p').hide();
          $('.catch-instagram-feed-gallery-widget-link-type')
            .parent('p')
            .show();
        } else {
          $('.catch-instagram-feed-gallery-widget-padding').parent('p').show();
          $('.catch-instagram-feed-gallery-widget-column').parent('p').show();
          $('.catch-instagram-feed-gallery-widget-link-type')
            .parent('p')
            .show();
        }
      }
    );

    $('body').on(
      'change',
      '.catch-instagram-feed-gallery-widget-link-type',
      function () {
        if ('none' === $(this).val()) {
          $('.catch-instagram-feed-gallery-widget-link-text')
            .parent('p')
            .hide();
        } else if ('load_more' === $(this).val()) {
          $('.catch-instagram-feed-gallery-widget-link-text')
            .parent('p')
            .show();
          $('.catch-instagram-feed-gallery-widget-link-text').val('Load More');
        } else {
          $('.catch-instagram-feed-gallery-widget-link-text')
            .parent('p')
            .show();
          $('.catch-instagram-feed-gallery-widget-link-text').val(
            'View On Instagram'
          );
        }
      }
    );
  });
})(jQuery);
