<?php
/**
 * The Catch Instagram Feed Gallery Widget Shortcode for the plugin.
 *
 * @link       catchplugins.com
 * @since      1.0.0
 *
 * @package    Catch_Instagram_Feed_Gallery_Widget_Pro
 * @subpackage Catch_Instagram_Feed_Gallery_Widget_Pro/includes
 */

/**
 * The Catch Instagram Feed Gallery Widget Shortcode for the plugin.
 *
 * @package    Catch_Instagram_Feed_Gallery_Widget_Pro
 * @subpackage Catch_Instagram_Feed_Gallery_Widget_Pro/includes
 * @author     Catch Plugins <info@catchplugins.com>
 */
class Catch_Instagram_Feed_Gallery_Widget_Pro_Shortcode {

	/**
	 * Our Catch Instagram Feed Gallery Widget shortcode.
	 * Constructor function
	 */
	function __construct() {

		add_shortcode( 'catch-instagram-feed-gallery-widget', array( $this, 'catch_instagram_feed_gallery_widget_shortcode' ) );

	}

	/**
	 * Our Catch Instagram Feed Gallery Widget shortcode.
	 * Prints Featured Content data styled to look good on *any* theme.
	 *
	 * @param  array $atts Widget attributes.
	 */
	static function catch_instagram_feed_gallery_widget_shortcode( $atts ) {

		// Default attributes.
		$atts = shortcode_atts(
			array(
				'title'     => esc_html__( 'Social Gallery and Widget', 'catch-instagram-feed-gallery-widget-pro' ),
				'username'  => '',
				'type'      => 'users',
				'layout'    => 'default',
				'padding'   => 0,
				'column'    => 'six-columns',
				'number'    => 6,
				'size'      => 'standard_resolution',
				'target'    => 0,
				'counts'    => 0,
				'lightbox'  => 0,
				'link_type' => 'load_more',
				'link_text' => esc_html__( 'Load More', 'catch-instagram-feed-gallery-widget-pro' ),
				'element'   => 'shortcode',
			),
			$atts,
			'catch-instagram-feed-gallery-widget-pro'
		);

		// A little sanitization.
		$atts['columns'] = sanitize_text_field( $atts['title'] );

		$atts['username'] = sanitize_text_field( $atts['username'] );

		$atts['type'] = sanitize_key( $atts['type'] );

		$atts['layout'] = sanitize_key( $atts['layout'] );

		$atts['padding'] = catch_instagram_feed_gallery_widget_pro_sanitize_checkbox( $atts['padding'] );

		$atts['column'] = sanitize_key( $atts['column'] );

		$atts['number'] = catch_instagram_feed_gallery_widget_pro_sanitize_number_range( $atts['number'] );

		$atts['size'] = sanitize_key( $atts['size'] );

		$atts['target'] = catch_instagram_feed_gallery_widget_pro_sanitize_checkbox( $atts['target'] );

		$atts['counts'] = catch_instagram_feed_gallery_widget_pro_sanitize_checkbox( $atts['counts'] );

		$atts['lightbox'] = catch_instagram_feed_gallery_widget_pro_sanitize_checkbox( $atts['lightbox'] );

		$atts['link_type'] = sanitize_key( $atts['link_type'] );

		$atts['link_text'] = sanitize_text_field( $atts['link_text'] );

		$atts['element'] = 'shortcode';

		$catch_instagram_feed_gallery_widget_helper = new Catch_Instagram_Feed_Gallery_Widget_Pro_Helper();

		return $catch_instagram_feed_gallery_widget_helper->display( $atts );

	}
}

/**
 * Function run_catch_instagram_feed_gallery_widget_shortcode.
 */
function run_catch_instagram_feed_gallery_widget_pro_shortcode() {

	$shortcode = new Catch_Instagram_Feed_Gallery_Widget_Pro_Shortcode;

}

run_catch_instagram_feed_gallery_widget_pro_shortcode();
