<?php

function catch_instagram_pro_assets() {

	// Scripts.
	wp_enqueue_script(
		'catch-instagram-block-js', // Handle.
		plugins_url( 'instagram-pro-block/blocks.build.js', dirname( __FILE__ ) ), // Block.build.js: We register the block here. Built with Webpack.
		array( 'wp-blocks', 'wp-i18n', 'wp-element', 'wp-components', 'wp-editor' ), // Dependencies, defined above.
		false // Enqueue the script in the footer.
	);

	// Styles.
	wp_enqueue_style(
		'catch-instagram-block-editor-css', // Handle.
		plugins_url( 'instagram-pro-block/blocks.editor.build.css', dirname( __FILE__ ) ), // Block editor CSS.
		array( 'wp-edit-blocks' ) // Dependency to include the CSS after it.
	);

} // End function catch_guten_cgb_editor_assets().

// Hook: Editor assets.
add_action( 'enqueue_block_editor_assets', 'catch_instagram_pro_assets' );

function catch_instagram_pro_init() {

	global $pagenow;

	if ( 'post.php' === $pagenow || 'post-new.php' == $pagenow ) {

		wp_enqueue_script( 'catch-instagram-feed-gallery-widget-pro-imageLoaded', plugins_url( 'instagram-pro-block/imagesloaded.pkgd.js', dirname( __FILE__ ) ), array( 'jquery' ), 'version', false );
		wp_enqueue_script( 'catch-instagram-feed-gallery-widget-pro-masonry', plugins_url( 'instagram-pro-block/masonry.pkgd.js', dirname( __FILE__ ) ), array( 'jquery' ), 'version', false );
		wp_enqueue_script( 'catch-instagram-feed-gallery-widget-pro-lightbox', plugins_url( 'instagram-pro-block/jquery.prettyPhoto.js', dirname( __FILE__ ) ), array( 'jquery' ), 'version', false );
		wp_enqueue_script( 'catch-instagram-feed-gallery-widget-pro', plugins_url( 'instagram-pro-block/catch-instagram-feed-gallery-widget-public.js', dirname( __FILE__ ) ), array( 'jquery', 'catch-instagram-feed-gallery-widget-pro-imageLoaded', 'catch-instagram-feed-gallery-widget-pro-masonry', 'catch-instagram-feed-gallery-widget-pro-lightbox' ), '1.5', false );

	}

}

add_action( 'init', 'catch_instagram_pro_init' );

// Hook the post rendering to the block
if ( function_exists( 'register_block_type' ) ) :

	register_block_type(
		'catch-instagram-block/catch-instagram-block',
		array(
			'attributes'      => array(
				'type'      => array(
					'type'    => 'string',
					'default' => 'users',
				),
				'username'  => array(
					'type'    => 'string',
					'default' => '',
				),
				'number'    => array(
					'type'    => 'int',
					'default' => '6',
				),
				'layout'    => array(
					'type'    => 'string',
					'default' => 'default',
				),
				'column'    => array(
					'type'    => 'string',
					'default' => 'six-columns',
				),
				'padding'   => array(
					'type'    => 'bool',
					'default' => false,
				),
				'link_type' => array(
					'type'    => 'string',
					'default' => 'load_more',
				),
				'lightbox'  => array(
					'type'    => 'bool',
					'default' => false,
				),
				'counts'    => array(
					'type'    => 'bool',
					'default' => false,
				),
				'target'    => array(
					'type'    => 'bool',
					'default' => true,
				),
				'link_text' => array(
					'type'    => 'string',
					'default' => 'View On Instagram',
				),
			),
			'render_callback' => 'catch_instagram_pro_block_render_shortcode',
		)
	);

endif;

if ( class_exists( 'Catch_Instagram_Feed_Gallery_Widget_Pro_Helper' ) ) {

	add_shortcode( 'catch-instagram-block', 'catch_instagram_pro_block_render_shortcode' );

	function catch_instagram_pro_block_render_shortcode( $atts ) {

		$options          = catch_instagram_feed_gallery_widget_pro_get_options();
		$instance['type'] = $atts['type'];

		if ( 'users' === $atts['type'] ) {

			$instance['username'] = $options['username'];

		} else {

			$instance['username'] = $atts['username'];

		}

		$instance['number']    = $atts['number'];
		$instance['layout']    = $atts['layout'];
		$instance['column']    = $atts['column'];
		$instance['padding']   = $atts['padding'];
		$instance['link_type'] = $atts['link_type'];
		$instance['lightbox']  = $atts['lightbox'];
		$instance['counts']    = $atts['counts'];
		$instance['target']    = $atts['target'];
		$instance['link_text'] = $atts['link_text'];

		$catch_instagram_feed_gallery_widget_helper = new Catch_Instagram_Feed_Gallery_Widget_Pro_Helper();
		return $catch_instagram_feed_gallery_widget_helper->display( $instance );

	}
}
